'Program sterujcy wywietlaczem alfanumerycznym LCD 2*16 znakw
'w trybie pracy 4-bitowej

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
       'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
       'o czstotliwoci oscylatora
       'taktujcego mikrokontroler
Config Lcd = 16 * 2                                         'konfiguracja typu LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfiguracja linii, do ktrych
       'doczono wywietlacz
Dim I As Byte                                               'zmienna licznikowa

Cls                                                         'czyci LCD
Lcd "* Bascom AVR *"                                        'wywietlenie w pierwszej linii
       'tekstu * Bascom ABR *
Wait 1                                                      'opnienie 1 sekundy
Lowerline                                                   'wybieramy drugiej linii
Wait 1                                                      'czekaj
Lcd "  Przesuwaj  "                                         'wywietlenie w drugiej linii
       'tekstu Przesuwaj
Wait 1                                                      'opnienie 1 sekundy
For I = 1 To 10                                             'w ptli tekst zostanie
       'przesunity o 10 pozycji
 Shiftlcd Right                                             'w prawo dla wszystkich linii
       'wywietlacza
 Waitms 500                                                 'opnienie przesuni o 500 ms
Next I                                                      'zwikszenie I o jeden
For I = 1 To 10                                             'ptli tekst zostanie
       'przesunity o 10 pozycji
 Shiftlcd Left                                              'w lewo dla wszystkich linii
       'wywietlacza
 Waitms 500                                                 'opnienie przesunic o 500 ms
Next I                                                      'zwikszenie I o jeden
Locate 2 , 2                                                'ustawienie pozycji kursora na
       'drug lini i drug pozycj
Lcd "*"                                                     'wywietlenie na wybranej
       'pozycji kursora znaku *
Wait 1                                                      'opnienie 1 sekundy
Shiftcursor Right                                           'przesunicie kursora o jedn
       'pozycj w prawo
Lcd "%"                                                     'wywietlenie znaku % na
       'przesunitej pozycji kursora
Wait 1                                                      'opnienie 1 sekundy
Home Upper                                                  'wybranie pierwszej linii
       'i powrt kursora na jej
       'pocztek
Lcd "Inny tekst"                                            'zastpienie tekstu w pierwszej
       'linii tekstem Inny tekst
Wait 2                                                      'opnienie 2 sekundy
Cursor Off Noblink                                          'wyczenie kursora
Wait 2                                                      'opnienie 2 sekundy
Cursor On Blink                                             'wczenie migajcego kursora
Wait 2                                                      'opnienie 2 sekundy
Display Off                                                 'wyczenie wywietlacza
Wait 2                                                      'opnienie 2 sekundy
Display On                                                  'wczenie wywietlacza

       'definicja pierwszego wasnego
       'znaku
Deflcdchar 0 , 31 , 31 , 31 , 31 , 30 , 28 , 24 , 16
       'definicja drugiego wasnego
       'znaku
Deflcdchar 1 , 1 , 3 , 7 , 15 , 31 , 31 , 31 , 31
Cls                                                         'czyszczenie wywietlacza po
       'zdefiniowaniu wasnych znakw
Lcd Chr(0) ; Chr(1)                                         'wywietlenie zdefiniowanych
       'znakw
Wait 1                                                      'opnienie 1 sekundy

Cls                                                         'czyszczenie LCD

'przykad wykorzystania wewntrznego podprogramu _write_lcd
_temp1 = 56                                                 'warto wpisywana do rejestru
       'R24 wskazywanego przez _temp1
       'zostanie wywietlona
RCALL _write_lcd                                            'wywietlona zostanie warto 8
       'o kodzie ASCII 56
Wait 2                                                      'opnienie 2 sekundy
Lowerline                                                   'przejcie kursora do drugiej
       'linii wywietlacza
I = 150                                                     'wpisanie do zmiennej I wartoci
       '150
Lcd I                                                       'wywietlenie wartoci
       'zmiennej I
End                                                         'koniec programu
