'Program multipleksowego sterowania czterema wywietlaczami
'7-segmentowymi LED poprzez dekoder 4543
'cyfra zaadowana do A bdzie wywietlana na wywietlaczu 1
'cyfra zaadowana do B bdzie wywietlana na wywietlaczu 2
'cyfra zaadowana do C bdzie wywietlana na wywietlaczu 3
'cyfra zaadowana do D bdzie wywietlana na wywietlaczu 4
'zmienna Kr1 steruje kropk wywietlacza 1
'zmienna Kr2 steruje kropk wywietlacza 2
'zmienna Kr3 steruje kropk wywietlacza 3
'zmienna Kr4 steruje kropk wywietlacza 4
'czstotliwo sterowania cyfr wynosi 250 Hz
'czyli czstotliwo odwieania 4 wywietlaczy
'wynosi ok. 250/4 = 62 Hz

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
        'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
        'o czstotliwoci oscylatora
        'taktujcego mikrokontroler
Config Pind.0 = Output                                      'linia PD0 jako wyjciowa
Config Pind.1 = Output                                      'linia PD1 jako wyjciowa
Config Pind.2 = Output                                      'linia PD2 jako wyjciowa
Config Pind.3 = Output                                      'linia PD3 jako wyjciowa
Config Pind.7 = Output                                      'linia PD7 jako wyjciowa
Config Pinb.0 = Output                                      'linia PB0 jako wyjciowa
Config Pinb.1 = Output                                      'linia PB1 jako wyjciowa
Config Pinb.2 = Output                                      'linia PB2 jako wyjciowa
Config Pinb.3 = Output                                      'linia PB3 jako wyjciowa
Config Timer0 = Timer , Prescale = 256
        'konfiguracja Timer0 jako timer
        'z podziaem preskalera przez
        '256
Declare Sub Zapis_cyfry(cyfra As Byte)
        'deklaracja procedury
        'zapisujcej cyfr do dekodera
        '4543
On Timer0 Mult_wysw                                         'przerwanie od przepenienia
        'Timer0, skok nastpi do
        'podprogramu Mult_wysw
Dim A As Byte , B As Byte , C As Byte , D As Byte           'definicje zmiennych A, B, C, D
        'w ktrych bd przechowywane
        'wartoci do wywietlenia
Dim Nr_wysw As Byte                                         'zmienna okrelajca numer
        'zapalonego wywietlacza
Dim Kr1 As Bit , Kr2 As Bit ,   Kr3 As Bit , Kr4 As Bit                                   'zmienne bitowe sterujce
        'kropkami wywietlaczy
Dim I As Byte                                               'zmienna, ktrej warto bdzie
        'wywietlana na wywietlaczach
W1 Alias Portb.0                                            'przypisanie linii PB0 nazwy W1
W2 Alias Portb.1                                            'przypisanie linii PB1 nazwy W2
W3 Alias Portb.2                                            'przypisanie linii PB2 nazwy W3
W4 Alias Portb.3                                            'przypisanie linii PB3 nazwy W4
Kropki Alias Portd.7                                        'przypisanie linii PD7 nazwy
        'Kropki

Enable Interrupts                                           'odblokowanie globalnego systemu
        'przerwa
Enable Timer0                                               'odblokowanie przerwania od
        'przepenienia Timer0
Load Timer0 , 125                                           'zaadowanie do licznika
        'wartoci pocztkowej 131, bo
        '256 - 125 = 131
Set Kr1                                                     'wyczenie kropki
        'wywietlacza 1
Set Kr2                                                     'wyczenie kropki
        'wywietlacza 2
Set Kr3                                                     'wyczenie kropki
        'wywietlacza 3
Set Kr4                                                     'wyczenie kropki
        'wywietlacza 4

Do                                                          'pocztek nieskoczonej ptli
 A = I                                                      'wywietlenie na wywietlaczu 1
        'wartoci zmiennej I
 B = I                                                      'wywietlenie na wywietlaczu 2
        'wartoci zmiennej I
 C = I                                                      'wywietlenie na wywietlaczu 3
        'wartoci zmiennej I
 D = I                                                      'wywietlenie na wywietlaczu 4
        'wartoci zmiennej I
 Incr I                                                     'zwikszenie o 1 wartoci
        'zmiennej I
 If I = 11 Then                                             'jeli warto I osignie 11, to
  I = 0                                                     'wyzerowanie tej zmiennej
 End If
 Toggle Kr1                                                 'zmiana na przeciwny stanu bitu
        'sterujcego kropk
        'wywietlacza 1
 Toggle Kr3                                                 'zmiana na przeciwny stanu bitu
        'sterujcego kropk
        'wywietlacza 3
 Waitms 500                                                 'opnienie 500 ms
Loop                                                        'koniec ptli nieskoczonej
End                                                         'koniec programu

Sub Zapis_cyfry(cyfra As Byte)                              'definicja procedury zapisujcej
        'cyfr do ukadu 4543
 Cyfra = Cyfra And &B00001111                               'wyzerowanie zmiennej Cyfra 4
        'najbardziej znaczcych bitw
 Portd = Portd And &B11110000                               'zamaskowanie 4 bardziej
        'znaczcych bitw i wyzerowanie
        '4 mniej znaczcych bitw
        'rejestru PORTD
 Portd = Portd Or Cyfra                                     'wystawienie na port D wartoci
        'zmiennej Cyfra bez naruszenia 4
        'bardziej znaczcych bitw
        'rejestru PORTD
End Sub                                                     'koniec procedury

Mult_wysw:                                                  'podprogram przerwania od
        'przepenienia Timer0
 Load Timer0 , 125                                          'zaadowanie do licznika
        'wartoci pocztkowej
 Set W1                                                     'wygaszenie wywietlacza 1
 Set W2                                                     'wygaszenie wywietlacza 2
 Set W3                                                     'wygaszenie wywietlacza 3
 Set W4                                                     'wygaszenie wywietlacza 4
 Select Case Nr_wysw                                        'w zalenoci od wartoci
        'Nr_wysw
        'wykonaj:
 Case 0:                                                    'gdy Nr_wysw = 0 to
  Call Zapis_cyfry(a)                                       'wywoanie procedury zapisujcej
        'warto zmiennej A do ukadu
        '4543
  Kropki = Kr1                                              'wpisanie na linie PD7
        'sterujcej kropk wartoci bitu
        'Kr1 dla wywietlacza 1
  Reset W1                                                  'wczenie wywietlacza 1
 Case 1:                                                    'gdy Nr_wysw = 1 to
  Call Zapis_cyfry(b)                                       'wywoanie procedury zapisujcej
        'warto zmiennej B do ukadu
        '4543
  Kropki = Kr2                                              'wpisanie na linie PD7
        'sterujcej kropk wartoci bitu
        'Kr2 dla wywietlacza 2
  Reset W2                                                  'wczenie wywietlacza 2
 Case 2:                                                    'gdy Nr_wysw = 2 to
  Call Zapis_cyfry(c)                                       'wywoanie procedury zapisujcej
        'warto zmiennej C do ukadu
        '4543
  Kropki = Kr3                                              'wpisanie na linie PD7
        'sterujcej kropk wartoci bitu
        'Kr3 dla wywietlacza 3
  Reset W3                                                  'wczenie wywietlacza 3
 Case 3:                                                    'gdy Nr_wysw = 3 oraz
  Call Zapis_cyfry(d)                                       'wywoanie procedury zapisujcej
        'warto zmiennej D do ukadu
        '4543
  Kropki = Kr4                                              'wpisanie na linie PD7
        'sterujcej kropk wartoci bitu
        'Kr4 dla wywietlacza 4
  Reset W4                                                  'waczenie wywietlacza 4
 End Select                                                 'koniec instrukcji wyboru
 Incr Nr_wysw                                               'zwikszenie o jeden warto
        'Nr_wysw
 If Nr_wysw = 4 Then                                        'jeli warto Nr_wysw osignie
        '4 to
  Nr_wysw = 0                                               'zeruj warto Nr_wysw
 End If
Return                                                      'powrt z podprogramu przerwania

Kody7seg:                                                   'tablica staych Kody7seg
        'przechowujca kody
        'wywietlanych cyfr
'Kody cyfr
Data &B00111111 , &B00000110 , &B01011011 , &B01001111 , &B01100110,
Data &B01101101 , &B01111101 , &B00000111 , &B01111111 , &B01101111
