'Program monitora do symulacji sprztowej
'Oryginalna wersja tego pliku znajduje si w katalogu Samples
'pod nazw Basmon.bas
'dyrektywa $REGFILE musi odpowiada mikrokontrolerowi
'jaki jest symulowany

'$REGFILE = "2313def.dat"    'dyrektywa dla mikrokontrolera AT90S2313
$regfile = "m8def.dat"                                      'dyrektywa dla mikrokontrolera ATmega8

'dyrektywa $CRYSTAL musi odpowiada czstotliwoci taktujcej 'mikrokontroler

$crystal = 8000000                                          'czstotliwo taktowania 8 MHz
$crystal = 4000000                                          'czstotliwo taktowania 4 MHz

'Warto dyrektywy $BAUD musi odpowiada wartoci
'Baudrate, ustawionej dla emulatora terminala

$baud = 19200                                               'prdko transmisji dla mikrokontrolera

'Protok komunikacyjny polega na wysyaniu komendy, adresu oraz danej
'xyz
'^--- komenda W dla zapisu, R dla odczytu, T dla testu
' ^-- adres do zapisu lub do odczytu
'  ^- wartosc danej do zapisania lub odczytu w zalenoci
'     od wysanej komendy
'Po wysaniu komendy T jest zwracana warto znaku ASCII o kodzie 13.
'Jest to potwierdzenie prawidowej komunikacji ukadu z symulatorem.

'Definicje zmiennych
Dim Krk As Byte                                             'komenda
Dim Adr As Word                                             'adres
Dim Adrl As Byte , Adrh As Byte                             'zmienne dla bardziej i mniej
       'znaczcego bajtu adresu
Dim Vl As Byte                                              'zmienna na przesyan wartosc

'Ptla programu gwnego

Do                                                          'pocztek ptli
 Krk = Inkey()                                              'odczyt bajtu komendy z portu RS232
 If Krk = "T" Then                                          'jeeli odebrany znak T (komenda
       'sprawdzenia poczenia z ukadem), to
  Print Chr(13);                                            'odelij znak ASCII o kodzie 13
 Elseif Krk = "W" Then                                      'jeeli odebrany znak W
'- komenda zapisu, to
  Adr = Waitkey()                                           'czekaj na adres
  Vl = Waitkey()                                            'czekaj na warto do zapisania
  Out Adr , Vl                                              'zapisanie wartoci pod
       'przesanym adresem
  Print Chr(13);                                            'potwierdzenie zapisu wysaniem
       'znaku o kodzie ASCII 13
 Elseif Krk = "R" Then                                      'jeeli odebrany znak R
'- komenda odczytu, to
  Adr = Waitkey()                                           'czekaj na adres
  Vl = Inp(adr)                                             'pobierz warto spod przesanego
       'adresu
  Print Chr(vl);                                            'odelij odczytana warto przez
       'port RS232
 Elseif Krk = "O" Then                                      'jeeli odebrany znak O, to
  Adrl = Waitkey()                                          'czekaj na warto LSB adresu
  Adrh = Waitkey()                                          'czekaj na warto MSB adresu
  Vl = Waitkey()                                            'czekaj na dan
  Adr = Adrh * 256                                          'przelicz odebrane wartoci
  Adr = Adr + Adrl                                          'adresu na jeden adres 16-bitowy
  Out Adr , Vl                                              'zapisz odebran warto pod
       'obliczonym adresem
  Print Chr(13);                                            'potwierd zapis wysaniem znaku
       'o kodzie ASCII 13
 End If                                                     'koniec warunkw If...Then
Loop                                                        'koniec nieskoczonej ptli
End                                                         'koniec programu