'Program obsugi klawiatury matrycowej 2x2 w przerwaniu zgaszanym
'od przepenienia Timer0 - 8 MHz/1024/200 = ok. 39 Hz,
'co daje przerwanie co 1/39 = 26 ms

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
      'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
      'o czstotliwoci oscylatora
      'taktujcego mikrokontroler
Config Pinb.0 = Input                                       'linia PB0 jako wejciowa
Config Pinb.1 = Input                                       'linia PB1 jako wejciowa
Config Pinb.2 = Output                                      'linia PB2 jako wyjciowa
Config Pinb.3 = Output                                      'linia PB3 jako wyjciowa
Config Lcd = 16 * 2                                         'konfigurowanie typu
      'wywietlacza LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfigurowanie linii
      'mikrokontrolera, do ktrych
      'doczono LCD
Config Timer0 = Timer , Prescale = 1024
      'konfigurowanie Timer0 jako
      'timer z podziaem preskalera
      'przez 1024

On Timer0 Mult_kl                                           'konfigurowanie przerwania od
      'przepenienia Timer0, skok do
      'podprogramu Mult_kl

Dim Temp1 As Byte                                           'zmienna pomocnicza Temp1
Dim Temp2 As Byte                                           'zmienna pomocnicza Temp2
Dim Przycisk As Byte                                        'zmienna, do ktrej bdzie
      'wpisywany kod nacinietego
      'przycisku
Dim I As Byte                                               'zmienna licznikowa

W1 Alias Pinb.0                                             'przypisanie nazwie Pinb.0
      'nazwy W1
W2 Alias Pinb.1                                             'przypisanie nazwie Pinb.1
      'nazwy W2
Kol1 Alias Portb.2                                          'przypisanie nazwie Portb.2
      'nazwy Kol1
Kol2 Alias Portb.3                                          'przypisanie nazwie Portb.3
      'nazwy Kol2
Enable Interrupts                                           'odblokowanie globalnego systemu
      'przerwa
Enable Timer0                                               'odblokowanie przerwania od
      'przepenienia Timer0
Load Timer0 , 200                                           'wpisanie do licznika wartoci
      'pocztkowej 56, bo
      '256 - 200 = 56

Set Portb.0                                                 'doczenie do linii PB0
      'rezystora podcigajcego
Set Portb.1                                                 'doczenie do linii PB1
      'rezystora podcigajcego
Set Kol1                                                    'ustawienie linii Kol1
Set Kol2                                                    'ustawienie linie Kol2

Do                                                          'ptla gwna programu
 Cls                                                        'czyszczenie LCD
 Lcd Przycisk                                               'wywietlenie na LCD stanu
      'zmiennej Przycisk
 Waitms 100                                                 'opnienie 100 ms
Loop
End                                                         'koniec programu

Mult_kl:                                                    'podprogram przerwania, w ktrym
      'jest obsugiwana klawiatura
 Load Timer0 , 200                                          'wpisanie do licznika wartoci
      'pocztkowej 56
 For I = 1 To 2                                             'ptla wykonywana 2 razy
  If I = 1 Then                                             'jeli I = 1, to
   Reset Kol1                                               'zerowanie linii Kol1
  Else                                                      'w przeciwnym razie
   Set Kol1                                                 'ustawienie linii Kol1
   Reset Kol2                                               'i zerowanie linii Kol2
  End If
  If W1 = 0 Or W2 = 0 Then                                  'jeli przy I = 1 lub I = 2
      'wejcia W1 lub W2 maja stany
      'niskie - naciniety przycisk,
      'to
   Temp1 = Pinb And &B00000011
      'zapisanie do zmiennej Temp1
      'wartoci dwch najmniej
      'znaczcych bitw rejestru PINB
'- linie W1 i W2
   Exit For                                                 'opuszczenie ptli For...Next
  Else                                                      'w przeciwnym razie
   Temp1 = 0                                                'wyzerowanie zmiennej Temp1
  End If
 Next I                                                     'zwikszenie o 1 wartoci I
 If Temp2 = Temp1 Then                                      'jeli wartoci w Temp2 oraz
      'Temp1 s sobie rwne, to
  Przycisk = Temp1                                          'zapisanie kodu nacinitego
      'przycisku do zmiennej Przycisk
  If I = 2 Then                                             'jeli I = 2, to
   Przycisk = Przycisk + 2                                  'dodanie do zmiennej Przycisk
      'wartoci 2, gdy odczytano
      'stany przyciskw
      'drugiego wiersza
  End If
 Else                                                       'w przeciwnym razie
  Temp2 = Temp1                                             'zapisanie wartoci Temp1 do
      'zmiennej Temp2
 End If
 Set Kol1                                                   'ustawienie linii Kol1
 Set Kol2                                                   'ustawienie linii Kol2
Return                                                      'powrt z podprogramu przerwania