'Program odbierajcy sygnay nadawane w standardzie RC5
'w przerwaniu Int0
'Na LCD bd wywietlane informacje o adresie oraz numerze komendy

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
       'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
       'o czstotliwoci oscylatora
       'taktujcego mikrokontroler
Config Lcd = 16 * 2                                         'konfiguracja typu wywietlacza
       'LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfiguracja linii
       'mikrokontrolera do ktrych
       'doczono wywietlacz
       'LCD
Config Int0 = Low Level                                     'konfigurowanie przerwania Int0,
       'ktre bdzie wywoywane niskim
       'poziomem na wejciu INT0
Config Rc5 = Pind.2                                         'konfiguracja linii, do ktrej
       'doczono odbiornik
       'podczerwieni
On Int0 Pobr_rc5                                            'po wystpieniu przerwania Int0
       'nastpi skok do podprogramu
       'Pobr_rc5
Dim Address As Byte , Command As Byte
       'definicje zmiennych dla
       'instrukcji Getrc5
Dim Odebr_kod As Bit                                        'flaga wskazujca na odebranie
       'kodu danych w kodzie RC5
Enable Interrupts                                           'odblokowanie przerwa
       'globalnych
Enable Int0                                                 'odblokowanie przerwania Int0

Set Odebr_kod                                               'ustawienie flagi Odebr_kod

Do                                                          'pocztek nieskoczonej ptli
 If Odebr_kod = 1 Then                                      'jeli odebrano kod RC5, to
  Cls                                                       'czyszczenie LCD
  Lcd "Adres: " ; Address                                   'wywietlenie w pierwszej linii
       'LCD otrzymanego adresu po
       'napisie Adres:
  Lowerline                                                 'kursor do drugiej linii LCD
  Lcd "Komenda:" ; Command                                  'wywietlenie w drugiej linii
       'LCD otrzymanego numeru komendy
       'po napisie Komenda:
  Reset Odebr_kod                                           'wyzerowanie flagi Odebr_kod
  Enable Int0                                               'odblokowanie przerwania Int0
 End If
Loop
End                                                         'koniec programu

Pobr_rc5:                                                   'podprogram przerwania Int0
 Disable Int0                                               'zablokowanie przerwania Int0
 Enable Interrupts                                          'odblokowanie przerwa
       'globalnych
 Getrc5(address , Command)                                  'pobranie adresu oraz komendy
       'nadanej z pilota podczerwieni
 Command = Command And &B01111111                           'wyzerowanie najbardziej
       'znaczcego bitu otrzymanej
       'komendy
 Set Odebr_kod                                              'ustawienie flagi odebrania kodu
       'RC5
Return                                                      'powrt z przerwania
