'Przykad wykorzystania Timer0 do generowania w przerwaniu
'1 sekundowych odcinkw czasu
'Program co sekund w przerwaniu zmienia na przeciwny stan linii
'PD0 sterujcej diod LED
'Przerwanie od przepenienia Timer0 jest generowane co 8 ms
'- 8MHz/256/250 = 125, a 1/125 s = 8 ms
'Zliczenie 125 odcinkw 8 ms da 1 sekund

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
       'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o
       'czstotliwoci oscylatora
       'taktujcego mikrokontroler
Config Pind.0 = Output                                      'linia PD0 jako wyjciowa
Config Timer0 = Timer , Prescale = 256
       'konfiguracja Timer0 jako timera
       'z podziaem preskalera przez
       '256

On Timer0 Odmierz_1s                                        'przerwanie od przepenienia
       'Timer0 o etykiecie Odmierz_1s

Dim Licz_8ms As Byte                                        'zmienna pomocnicza zliczajca
       'odcinki czasu rwne 8 ms

Enable Interrupts                                           'odblokowanie globalnego systemu
       'przerwa
Enable Timer0                                               'odblokowanie przerwania od
       'przepenienia Timer0
Load Timer0 = 250                                           'warto pocztkowa Timer0

Do                                                          'ptla nieskoczona
Loop
End                                                         'koniec programu

Odmierz_1s:                                                 'pocztek podprogramu obsugi
       'przerwania od przepenienia
       'Timer0
 Load Timer0 = 250                                          'warto pocztkowa Timer0
 Incr Licz_8ms                                              'zwiksz o jeden warto
       'zmiennej pomocniczej Licz_8ms
 If Licz_8ms = 125 Then                                     'jeeli warto tej zmiennej
       'rwna 125 (125*8 ms = 1) to
       'odliczono 1 sekund
  Licz_8ms = 0                                              'zerowanie zmiennej licznikowej
  Toggle Portd.0                                            'zmie na przeciwny stan linii
       'PD0 portu D mikrokontrolera
 End If                                                     'koniec warunku If...Then
Return                                                      'powrt z przerwania
